__copyright__ = "Copyright (c) 2007 CollabNet, Inc. All rights reserved."

from app.scripts import BaseCreateRuntimeScript
import app.util
import app.batch
import service.util
import service.constants
import os
import commands
import sys

class CreateRuntimeScript(BaseCreateRuntimeScript):

    scriptDescription = "Setup Apache system configuration"

    def createRuntime(self):
        if self.cfg['SSL'] != "on":
           return

        sysConfigPath = os.path.join('/etc', 'sysconfig')
        httpdSysConfFile = os.path.join(sysConfigPath, 'httpd')

        entryDisableSSLCompression = 'export OPENSSL_NO_DEFAULT_ZLIB=1'
        if (not self.checkConfEntry(httpdSysConfFile, entryDisableSSLCompression)):
           self.appendConfFile(httpdSysConfFile, "")
           self.appendConfFile(httpdSysConfFile, entryDisableSSLCompression)

    def appendConfFile(self, confFile, content):

        wfHandler = open (confFile, 'a')
        wfHandler.write(content + "\n")
        wfHandler.close()
        return

    def checkConfEntry(self, confFile, confEntry):

        fHandler = open(confFile, 'r')
        confLines = fHandler.read().split("\n")
        fHandler.close()

        if (len(filter(lambda x: x == confEntry, confLines)) > 0):
           return True
        return False

