__copyright__ = "Copyright (c) 2007 CollabNet, Inc. All rights reserved."

from app.scripts import BaseCreateRuntimeScript
import app.util
import app.batch
import app.preprocessor
import os

class CreateRuntimeScript(BaseCreateRuntimeScript):

    scriptDescription = "Set Apache User Ownership"

    def createRuntime(self):
         app.util.runSystem("chown -R %s:%s %s" % (self.cfg['HTTPD_USER'],
                             self.cfg['HTTPD_GROUP'],
                             self.cfg['HTTPD_LOG_DIR']), self.log)
         app.util.runSystem("chmod -R 755 %s" % (self.cfg['HTTPD_LOG_DIR']), self.log)
         # Change permissions for wsgi socket directory as well
         wsgiSocketDir = self.cfg["HTTPD_WSGI_SOCKET_DIR"]
         if not os.path.exists(wsgiSocketDir):
             os.makedirs(wsgiSocketDir)

         app.util.runSystem("chown -R %s:%s %s" % (self.cfg['HTTPD_USER'],
                                                   self.cfg['HTTPD_GROUP'],
                                                   wsgiSocketDir), self.log)
         app.util.runSystem("chmod -R 755 %s" % (wsgiSocketDir), self.log)

