from app.scripts import BaseBootstrapScript
import app.util
import os
import pwd
import commands
import shutil

class BootstrapScript(BaseBootstrapScript):

    scriptDescription = "Create cracklib folder"

    def setLongDirectoryPermissions(self, dir, uid, gid):
        if os.path.exists(dir):
            os.system('chown -R %d:%d %s' % (uid, gid, dir))

    def bootstrap(self):
        cracklibDir = os.path.join(self.cfg['DATA_DIR'], "cracklib");
        if os.path.exists(cracklibDir):
            pass
        else:
            os.makedirs(cracklibDir);
            httpd_user = self.cfg['APP_USER']
            httpd_group = self.cfg['APP_GROUP']
            httpd_uid, httpd_gid = pwd.getpwnam(httpd_user)[2:4]
            self.setLongDirectoryPermissions(os.path.join(self.cfg['DATA_DIR'], 'cracklib'),
                                httpd_uid, httpd_gid)
            filename = 'words.en-us'
            wordPath = os.path.join(cracklibDir, filename)
            value = self.cfg['DICTIONARY_SOURCE']
            shutil.copyfile(value, wordPath)
            app.util.runSystem("chown %s:%s %s" % (httpd_user,httpd_group,wordPath),self.log)
