﻿__copyright__ = "Copyright (c) 2007-2014 CollabNet, Inc. All rights reserved."

from app.scripts import BaseCreateRuntimeScript
import app.util
import app.batch
import app.preprocessor
import os
import commands

class CreateRuntimeScript(BaseCreateRuntimeScript):

    scriptDescription = "Create TeamForge Configuration properties"

    def createRuntime(self):
        # Write to a temporary file
        tempConfFile = os.path.join(self.cfg['RUNTIME_DIR'], "conf", "sourceforge_configuration.properties") + ".tmp"

        app.batch.ConfigBatch(self.log) \
            .addFolder(os.path.join(app.defaults.DEFAULT_SERVICE_DIR, 'ctfcore-app', 'conf-snippets', 'sourceforge_configuration.properties.d')) \
            .evaluateIntoFile(tempConfFile)

        fileHandle = open(tempConfFile, 'a')

        if self.cfg.has_key('SOURCEFORGE_CONFIGURATION_PROPERTIES_APPEND'):
            fileHandle.write(self.cfg['SOURCEFORGE_CONFIGURATION_PROPERTIES_APPEND'] + "\n")

        fileHandle.close()

        # Read contents of the temp file
        origConfFile = open(tempConfFile, 'r')
        confTokens = origConfFile.read()
        origConfFile.close()
        # Remove the temporary file
        os.remove(tempConfFile)

        lines = confTokens.splitlines()
        confFilePath = os.path.join(self.cfg['RUNTIME_DIR'], "conf", "sourceforge_configuration.properties")

        newConfFile = open(confFilePath, 'w')

        # Check if the configuration file has database parameters
        databaseTokens = []
        while len(lines) > 0:
            line = lines.pop(0)
            if not line:
                newConfFile.write("\n")
                continue
            if line.find("database.username") == -1 and \
                line.find("database.password") == -1 and \
                line.find("database.host") == -1 and \
                line.find("database.name") == -1 and \
		line.find("database.*") == -1 and \
		line.find("reporting.database.username") == -1 and \
                line.find("reporting.database.password") == -1 and \
                line.find("reporting.database.host") == -1 and \
                line.find("reporting.database.name") == -1 and \
                line.find("reporting.database.*") == -1:
                newConfFile.write(line + "\n")
            else:
                databaseTokens.append(line)

        if self.cfg.has_key('TEST_SUPPORT_ENABLED') and self.cfg['TEST_SUPPORT_ENABLED'] == 'true':
	    # sharedSecret = commands.getoutput('/usr/bin/head -c 32 /dev/random | /usr/bin/openssl dgst -sha1 -hex')
            # newConfFile.write("shared.secret=%s\n" % sharedSecret)
            newConfFile.write("shared.secret=foo\n")
            # Write the database parameters to the configuration file, only if TEST_SUPPORT_ENABLED is true
            if databaseTokens:
                newConfFile.write("\n".join(databaseTokens))

        newConfFile.close()

        app.util.runSystem("chown %s:%s %s" % (self.cfg["APP_USER"], self.cfg["APP_GROUP"], confFilePath), self.log)
        app.util.runSystem("chmod 604 %s" % confFilePath, self.log)
