__copyright__ = "Copyright (c) 2007 CollabNet, Inc. All rights reserved."

from app.scripts import BaseBootstrapScript
import app.util
import os
import app.schemerator

class BootstrapScript(BaseBootstrapScript):

    scriptDescription = "Bootstrap App database"

    def bootstrap(self):
        dbHost = self.cfg['ctfcore-database-admin-oracle/dependency/ctfcore-database/jdbc/host']
        dbPort = self.cfg['ctfcore-database-admin-oracle/dependency/ctfcore-database/jdbc/port']
        dbName = self.cfg['DATABASE_NAME']

        dbUrl = "jdbc:oracle:thin:@%s:%s:%s" % (dbHost, dbPort, dbName)

        try:
            app.schemerator.Schemerator(
                self.cfg['BOOTSTRAP_JAR'],
                dbUrl,
                self.cfg.get('DATABASE_USERNAME'),
                self.cfg.get('DATABASE_PASSWORD')).run(self.log)

        except app.schemerator.SchemeratorSchemaExistsException:
            raise Exception("Database schema already exists. To recreate the schema, "+
                            "drop and recreate the database user (%s) on %s" %
                            (self.cfg.get('DATABASE_USERNAME'), dbHost))
