﻿from app.scripts import BaseMigrationScript

import os
import app.util

class MigrationScript(BaseMigrationScript):

    scriptDescription = "Migrate CTF Reports Database to latest schema"

    def migrate(self):
        databaseType = self.cfg['DATABASE_TYPE']

        jdbcUrl = "jdbc:oracle:thin:@%s:%s:%s" % \
            (self.cfg['ctfcore-datamart-admin-oracle/dependency/ctfcore-database/jdbc/host'], self.cfg['ctfcore-datamart-admin-oracle/dependency/ctfcore-database/jdbc/port'], self.cfg['DATABASE_NAME'])

        reportsJdbcUrl = "jdbc:oracle:thin:@%s:%s:%s" % \
            (self.cfg['ctfcore-datamart-admin-oracle/dependency/ctfcore-datamart/jdbc/host'], self.cfg['ctfcore-datamart-admin-oracle/dependency/ctfcore-datamart/jdbc/port'], self.cfg['REPORTS_DATABASE_NAME'])

        app.migratorator.Migratorator.forDatamart(
            os.path.join(self.cfg['DISTRIBUTION_DIR'], "migratorator/migratorator.jar"),
            jdbcUrl,
            self.cfg['DATABASE_USERNAME'],
            self.cfg['DATABASE_PASSWORD'],
            reportsJdbcUrl,
            self.cfg['REPORTS_DATABASE_USERNAME'],
            self.cfg['REPORTS_DATABASE_PASSWORD']).migrate(self.log)
