__copyright__ = "Copyright (c) 2007 CollabNet, Inc. All rights reserved."

from app.scripts import BaseBootstrapScript
import app.util
import os
import app.pgdbadmin
import app.schemerator

class BootstrapScript(BaseBootstrapScript):

    scriptDescription = "Bootstrap Reporting database"

    def bootstrap(self):
        dbHost = self.cfg['ctfcore-datamart-admin/dependency/ctfcore-datamart/jdbc/host']
        dbName = self.cfg['REPORTS_DATABASE_NAME']
        dbPort = self.cfg['ctfcore-datamart-admin/dependency/ctfcore-datamart/jdbc/port']
        dbSSL  = self.cfg['REPORTS_DATABASE_SSL']

        dbUrl = "jdbc:postgresql://%s:%s/%s" % (dbHost, dbPort, dbName)
        if dbSSL == "on":
            dbUrl += '?ssl=true&sslfactory=org.postgresql.ssl.NonValidatingFactory&'

        try:
            app.schemerator.Schemerator(
                self.cfg['REPORTS_BOOTSTRAP_JAR'],
                dbUrl,
                self.cfg.get('REPORTS_DATABASE_USERNAME'),
                self.cfg.get('REPORTS_DATABASE_PASSWORD')).run(self.log)

        except app.schemerator.SchemeratorSchemaExistsException:
            raise Exception("Database schema already exists. To recreate the schema, "+
                            "bootstrap the service 'ctfcore-datamart-postgres[-cohosted]' first")

        db = app.pgdbadmin.PGCTFDBManager(
            dbName,
            self.cfg.get('REPORTS_DATABASE_USERNAME'),
            self.cfg.get('REPORTS_DATABASE_PASSWORD'),
            self.cfg.get('REPORTS_DATABASE_READ_ONLY_USER'),
            self.cfg.get('REPORTS_DATABASE_READ_ONLY_PASSWORD'),
            self.log,
            dbPort,
            dbHost,
            self.cfg.get('REPORTS_PGPASSFILE'))
        db.grantReadOnlyPermissionsForAllTablesInSchema()
