__copyright__ = "Copyright (c) 2013 CollabNet, Inc. All rights reserved."

from app.scripts import BaseOptionScript
import app.landscape

class OptionScript(BaseOptionScript):
    """ configure JAMES_ACCEPTED_RELAYS """

    def optionSnippet(self):
        site = app.landscape.Landscape.getSite()

        acceptedRelays = set(["127.0.0.1", self.cfg["APPSERVER_DOMAIN"]])

        # Allow all Gerrit servers to relay email.
        for machine in site.getMachinesByService('gerrit'):
            acceptedRelays.add(machine.getPublicName())
            acceptedRelays.add(machine.getPhysicalName())
            acceptedRelays.add(machine.getIp())

        # Allow all CTF Core servers to relay email.
        for machine in site.getMachinesByService('ctfcore'):
            acceptedRelays.add(machine.getPublicName())
            acceptedRelays.add(machine.getPhysicalName())
            acceptedRelays.add(machine.getIp())

        return "JAMES_ACCEPTED_RELAYS=%s\n" % ",".join(acceptedRelays)
