__copyright__ = "Copyright (c) 2007 CollabNet, Inc. All rights reserved."

from app.scripts import BaseBootstrapScript
import app.util
import os

class BootstrapScript(BaseBootstrapScript):

    scriptDescription = "Create Data folders"

    def __wipe(self, folder):
        if os.path.exists(folder):
            app.util.runSystem("rm -rf %s" % folder, self.log)
        os.makedirs(folder)
        app.util.runSystem("chown -R %s:%s %s" % (self.cfg['JAMES_USER'], self.cfg['JAMES_GROUP'], folder), self.log)

    def bootstrap(self):
        dataDir = self.cfg['DATA_DIR']
        if os.path.islink(dataDir):
            dataDir = os.readlink(dataDir)
        if not os.path.exists(dataDir):
            os.makedirs(dataDir)

        self.__wipe(self.cfg['SEARCH_INDEX_LOCATION'])
